<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/10/2004 *
 * ===============                              Last change: 07/10/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : register_functions.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for register extension         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer register-Erweiterung     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

//
function ifRequiredRegisterFieldsAreSet (&$array) {
	// By default all is fine
	$ret = true;
	foreach ($array as $key => $value) {
		// Check all fields that must register
		$result = SQL_QUERY("SELECT `id` FROM `{?_MYSQL_PREFIX?}_must_register` WHERE `field_name`='".$key."' AND `field_required`='Y' LIMIT 1",
			__FUNCTION__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Check if extension country is not found (you have to enter the 2-chars long country code) or
			// if extensions is present check if country code was selected
			//         01              2         21    12             3         32    234     5      54    4               43    34                      4    4      5      5432    2      3                      3210
			$country = ((!isExtensionActive('country')) || ((isExtensionActive('country')) && (((empty($value)) && ($key == 'cntry')) || (($key == 'country_code') && (!empty($value)))) && (!empty($array['country_code']))));
			if ((empty($value)) && ($country === false)) {
				// Required field not set
				$array[$key] = '!';
				$ret = false;
			} // END - if
		} // END - if

		// Free result
		SQL_FREERESULT($result);
	} // END - foreach

	// Return result
	return $ret;
}

// Generates a 'category table' for the registration form
function registerGenerateCategoryTable ($mode, $return=false) {
	$OUT = '';

	// Guests are mostly not interested in how many members has
	// choosen an individual category
	$AND = "WHERE `visible`='Y' ";

	// Admins are allowed to see every category...
	if (isAdmin()) $AND = '';

	// Look for categories
	$result = SQL_QUERY("SELECT `id`, `cat`, `visible` FROM `{?_MYSQL_PREFIX?}_cats` ".$AND." ORDER BY `sort` ASC",
		__FUNCTION__, __LINE__);

	if (SQL_NUMROWS($result) > 0) {
		// List alle visible modules (or all to the admin)
		$SW = 2;
		$OUT .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n";
		while ($content = SQL_FETCHARRAY($result)) {
			// Is the array element not set?
			if (!isPostRequestElementSet('cat', $content['id'])) {
				// Then set it
				setRequestPostElement('cat', array($content['id'] => ''));
			} // END - if

			// Prepare array for the template
			$content = array(
				'sw'    => $SW,
				'cat'   => $content['cat'],
				'def_y' => '',
				'def_n' => '',
				'id'    => $content['id'],
			);

			if ((postRequestElement('cat', $content['id']) == 'Y') || ((getConfig('register_default') == 'Y') && (!isPostRequestElementSet('cat', $content['id'])))) {
				$content['def_y'] = ' checked="checked"';
			} else {
				$content['def_n'] = ' checked="checked"';
			}

			// Load template and switch color
			$OUT .= loadTemplate('guest_cat_row', true, $content);
			$SW = 3 - $SW;
		}
		$OUT .= "</table>\n";

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// No categories setted up so far...
		$OUT .= loadTemplate('admin_settings_saved', true, getMessage('NO_CATEGORIES_VISIBLE'));
	}

	if ($return === true) {
		// Return generated HTML code
		return $OUT;
	} else {
		// Output directly (default)
		outputHtml($OUT);
	}
}

// Outputs a 'failed message'
function registerOutputFailedMessage ($messageId, $extra='') {
	if (empty($messageId)) {
		outputHtml('<div class="register_failed">' . $extra . '</div>');
	} else {
		outputHtml('<div class="register_failed">{--' . $messageId . '--}' . $extra . '</div>');
	}
}

// Run a filter for must-fillout fields
function FILTER_REGISTER_MUST_FILLOUT ($content) {
	// Get all fields for output
	$result = SQL_QUERY("SELECT `field_name`, `field_required` FROM `{?_MYSQL_PREFIX?}_must_register` ORDER BY `id` ASC",
		__FUNCTION__, __LINE__);

	while ($row = SQL_FETCHARRAY($result)) {
		$value = '';
		if ($row['field_required'] == 'Y') $value = "<span class=\\\"guest_failed\\\">&nbsp;(*)</span>";
		// @TODO Rewrite these constants
		$content['must_fillout_'.strtolower($row['field_name']).''] = $value;
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Return it
	return $content;
}

//
?>
