<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/26/2008 *
 * ===============                              Last change: 08/26/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache-filter.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Use this code if you don't want to run this cache loader on installation phase
if (isInstallationPhase()) return;

// Next cached table is the filteruration (filter)...
if (($GLOBALS['cache_instance']->loadCacheFile('filter')) && ($GLOBALS['cache_instance']->extensionVersionMatches('sql_patches'))) {
	// Load filter from cache
	$GLOBALS['cache_array']['filter'] = $GLOBALS['cache_instance']->getArrayFromCache();
} elseif ((getOutputMode() != '1') && (isExtensionInstalled('sql_patches'))) {
	// Create cache file here
	$GLOBALS['cache_instance']->init('FILTER');

	// Load all modules and their data
	$result = SQL_QUERY('SELECT * FROM `{?_MYSQL_PREFIX?}_filters` ORDER BY `filter_name` ASC, `filter_id` ASC', __FILE__, __LINE__);
	while ($content = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$GLOBALS['cache_instance']->addRow($content);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Close the cache
	$GLOBALS['cache_instance']->storeExtensionVersion('sql_patches');
	$GLOBALS['cache_instance']->finalize();

	// Include loader again
	loadInclude('inc/loader/'.basename(__FILE__));
}

// [EOF]
?>
